mlib = {}

function mlib.get_distance( x1, y1, x2, y2 )
	name = math.sqrt( ( x1 - x2 ) ^ 2 + ( y1 - y2 ) ^ 2 )
	return name
end

function mlib.get_midpoint( x1, y1, x2, y2 )
	name = { ( x1 + x2 ) / 2, ( y1 + y2 ) / 2 }
	return name
end

function mlib.get_linear_slope( x1, y1, x2, y2 )
	if x1 == x2 then error( "Slope error:\n Tried to get the linear slope of a nonlinear or vertical" ) end
	name = ( y1 - y2 ) / ( x1 - x2 )
	return name
end

function mlib.get_perpendicular_slope( slope )
	name = -1 / slope
	return name
end

function mlib.get_perpendicular_bisector( slope, x1, y1, x2, y2 )
	perp_slope = mlib.get_perpendicular_slope( slope )
	midpoint = mlib.get_midpoint( x1, y1, x2, y2 )
	name = { perp_slope, midpoint }
	return name
end

function mlib.get_y_intercept( slope, x, y )
	name = y - slope * x
	return name
end

function mlib.get_exponential_function( x1, y1, x2, y2 )
	y = y2 / y1
	x = x2 - x1
	b = y ^ ( 1 / x )
	a = ( b ^ x2 ) / y2 
	a = 1 / a
	name = { a, b }
	return name
end

function mlib.draw_line( slope, y_intercept )
	love.graphics.line( 0, y_intercept, 800, slope * 800 + y_intercept )
end

function mlib.draw_line_standard( slope, y_intercept )
	slope = slope * -1
	y_intercept = y_intercept + 600
	love.graphics.line( 0, y_intercept, 800, slope * 800 + y_intercept )
end

function mlib.draw_exponential_function( a, b )
	for i = 0, 800 do
		love.graphics.line( i, a * ( b ) ^ i, i + 1, a * ( b ) ^ ( i + 1 ) )
	end
end

function mlib.draw_exponential_function_standard( a, b )
	for i = 0, 800 do
		love.graphics.line( i, 600 - ( a * ( b ) ^ i ), i + 1, 600 - ( a * ( b ) ^ ( i + 1 ) ) )
	end
end

function mlib.get_triangle_area( sidelength_1, sidelength_2, sidelength_3 )
	s = ( sidelength_1 + sidelength_2 + sidelength_3 ) / 2
	name = math.sqrt( s * ( s - sidelength_1 ) * ( s - sidelength_2 ) * ( s - sidelength_3 ) )
	return name
end

function mlib.get_triangle_height( area, base )
	name = ( 2 * area ) / base
	return name
end

function mlib.get_circle_area( radius )
	name = math.pi * ( r ^ 2 )
	return name
end

function mlib.get_mean( ... )
	name = { ... }
	mean = 0
	for i = 1, #name do
		mean = mean + name[i]
	end
	mean = mean / #name
	return mean
end

function mlib.get_median( ... )
	name = { ... }
	for i = 1, #name do
		if #name > 2 then
			least = math.min( unpack( name ) )
			largest = math.max( unpack( name ) )
			for ii = 1, #name do
				if name[ii] == least then 
					table.remove( name, ii )
					break
				end
			end
			for ii = 1, #name do
				if name[ii] == largest then
					table.remove( name, ii )
					break
				end
			end
		elseif #name == 2 then
			median = mlib.get_mean( name[1], name[2] )
			return median
		elseif #name == 1 then
			median = name[1]
			return median
		end
	end
end

function mlib.get_mode( ... ) --bimodial and no mode are nil
	name = { ... }
	ordered = {}
	num = {}
	for i = 1, #name do
		if #name > 0 then
			least = math.min( unpack( name ) )
			table.insert( ordered, least )
			for ii = 1, #name do
				if name[ii] == least then 
					table.remove( name, ii )
					break
				end
			end
		end
	end
	if #ordered == 1 then
		mode = ordered[1]
	else
		for i = 1, #ordered do
			for ii = 1, #ordered do
				if not num[i] then num[i] = 1 end
				if ordered[i] == ordered[ii] and i ~= ii then
					num[i] = num[i] + 1
				end
			end
		end
		mode = math.max( unpack( num ) )
		for i = 1, #num do
			for ii = 1, #num do
				if ( num[i] == mode ) and ( i ~= ii ) then
					mode_1 = ordered[i]
				end
			end
		end
		for i = 1, #num do
			if num[i] == mode then
				mode_2 = ordered[i]
				break
			end
		end
		if mode_1 == mode_2 then mode = mode_1 else mode = nil end
	end
	return mode
end

function mlib.root( number, root )
	name = number ^ ( 1 / root )
	return name
end

function mlib.is_prime( num )
	if math.floor( math.sqrt( num ) ) == math.sqrt( num ) then
		name = false
	else
		for i = 2, num do
			if num ~= i and num % i == 0 then
				name = false 
				break
			else 
				name = true
			end
		end
	end
	return name
end